
(function() {
	require('TTS/js/Core/Array');
	var util = require('util');
	var fs = require('fs');

	var Log = {
		GetLogDir: function () {
			if (process.env.SystemLog) {
				SystemLog = JSON.parse(process.env.SystemLog);
				return SystemLog.Dir;
			}
			return null;
		},
		GetLogLevels: function () {
			if (process.env.SystemLog) {
				SystemLog = JSON.parse(process.env.SystemLog);
				return SystemLog.Levels;
			}
			return [];
		},
		SetLogDir: function (logDir) {
			if (!fs.existsSync(logDir)) {
				fs.mkdirSync(logPath);
			}
			SystemLog = {};
			if (process.env.SystemLog) {
				SystemLog = JSON.parse(process.env.SystemLog);
			}
			SystemLog.Dir = logDir;
			process.env.SystemLog = JSON.stringify(SystemLog);
		},
		SetLogLevels: function (levels) {
			SystemLog = {};
			if (process.env.SystemLog) {
				SystemLog = JSON.parse(process.env.SystemLog);
			}
			SystemLog.Levels = levels;
			process.env.SystemLog = JSON.stringify(SystemLog);
		},
		Activity: function (module, data) {
			levels = Log.GetLogLevels();
			if (!levels.Contains('Activity')) {
				return;
			}
			ts = (new Date(Date.now())).toISOString();
			s = '';
			if (typeof(data) == 'string') {
				s = "(" + ts + ")" + module + ":" + data + "\n";
			}
			if (util.isArray(data)) {
				data.forEach(function (e, i, a) {
					s += "(" + ts + ")" + module + ":" + e + "\n";
				});
			}
			fs.appendFileSync(Log.GetLogDir()+"Activity", s, {encoding:'utf8'});
		},
		Error: function (module, data) {
			levels = Log.GetLogLevels();
			if (!levels.Contains('Error')) {
				return;
			}
			ts = (new Date(Date.now())).toISOString();
			s = '';
			if (typeof(data) == 'string') {
				s = "(" + ts + ")" + module + ":" + data + "\n";
			}
			if (util.isArray(data)) {
				data.forEach(function (e, i, a) {
					s += "(" + ts + ")" + module + ":" + e + "\n";
				});
			}
			fs.appendFileSync(Log.GetLogDir()+"Error", s, {encoding:'utf8'});
		},
		Warn: function (module, data) {
			levels = Log.GetLogLevels();
			if (!levels.Contains('Warn')) {
				return;
			}
			ts = (new Date(Date.now())).toISOString();
			s = '';
			if (typeof(data) == 'string') {
				s = "(" + ts + ")" + module + ":" + data + "\n";
			}
			if (util.isArray(data)) {
				data.forEach(function (e, i, a) {
					s += "(" + ts + ")" + module + ":" + e + "\n";
				});
			}
			fs.appendFileSync(Log.GetLogDir()+"Warn", s, {encoding:'utf8'});
		},
		Trace: function (module, data) {
			levels = Log.GetLogLevels();
			if (!levels.Contains('Trace')) {
				return;
			}
			ts = (new Date(Date.now())).toISOString();
			s = '';
			if (typeof(data) == 'string') {
				s = "(" + ts + ")" + module + ":" + data + "\n";
			}
			if (util.isArray(data)) {
				data.forEach(function (e, i, a) {
					s += "(" + ts + ")" + module + ":" + e + "\n";
				});
			}
			fs.appendFileSync(Log.GetLogDir()+"Trace", s, {encoding:'utf8'});
		},
		Debug: function (module, data) {
			levels = Log.GetLogLevels();
			if (!levels.Contains('Debug')) {
				return;
			}
			ts = (new Date(Date.now())).toISOString();
			s = '';
			if (typeof(data) == 'string') {
				s = "(" + ts + ")" + module + ":" + data + "\n";
			}
			if (util.isArray(data)) {
				data.forEach(function (e, i, a) {
					s += "(" + ts + ")" + module + ":" + e + "\n";
				});
			}
			fs.appendFileSync(Log.GetLogDir()+"Debug", s, {encoding:'utf8'});
		}
	};

	if (typeof(module) != 'undefined') {
		module.exports = Log;
	} else {
		this.Log = Log;
	}

})();
