////////////////////////////////////////////////////////////////////////////////
//          File Header
//  File: index.js (Js:System/index.js)
//  Description: JS System Module
//  Version: 1.0.0 (06/03/2014)
//  Url: http://code.ttsdesign.net/tiki-index.php?page=Js_System
//  Bugs: http://bugzilla.ttsdesign.net/describecomponents.cgi?product=Js%3ASystem
//  License: GPL-1.0+
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//  Main Function
(function() {
	fs = require('fs');

	if (!process.env.SystemLog) {
		logPath = process.env.HOME + "/.logs/";
		if (!fs.existsSync(logPath)) {
			fs.mkdirSync(logPath);
		}
		process.env.SystemLog = JSON.stringify({
			Dir: logPath,
			Levels: ["Activity","Error","Warn"]
		});
	}

	////////////////////////////////////////////////////////////////////////////
	//  Module Object
	var System = {
		Exec: require('child_process').exec,
		ExecSync: require('./ExecSync'),
		Log: require('./Log')
	};
	////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////
	//  Module Exports Setup
	if (typeof(module) != 'undefined') {
		module.exports = System;
	} else {
		this.System = System;
	}
	////////////////////////////////////////////////////////////////////////////

})();
////////////////////////////////////////////////////////////////////////////////
